"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var User_1 = __importDefault(require("./user/User"));
var Request_1 = __importDefault(require("./../lib/request/Request"));
var _misc = __importStar(require("./../util/Misc"));
var I18n_1 = __importDefault(require("./../lib/i18n/I18n"));
var TranslationParser_1 = __importDefault(require("./../lib/i18n/TranslationParser"));
var Client_1 = __importDefault(require("./../lib/client/Client"));
var ServiceClient_1 = __importDefault(require("./../lib/services/ServiceClient"));
var FrontendSDK = /** @class */ (function () {
    function FrontendSDK() {
        // Empty constructor
    }
    FrontendSDK.prototype.getUser = function (jwt) {
        return new User_1.default(jwt);
    };
    FrontendSDK.prototype.getRequest = function (endpoint) {
        return new Request_1.default(endpoint);
    };
    Object.defineProperty(FrontendSDK.prototype, "misc", {
        get: function () {
            return _misc;
        },
        enumerable: false,
        configurable: true
    });
    FrontendSDK.prototype.getTranslator = function (lang, texts) {
        if (!lang) {
            throw new Error('Language required');
        }
        if (!texts) {
            throw new Error('Translations required');
        }
        return new I18n_1.default(lang, texts);
    };
    FrontendSDK.prototype.getTranslationParser = function (dir) {
        if (!dir || typeof dir !== 'string') {
            throw new Error('Directory required');
        }
        return new TranslationParser_1.default(dir);
    };
    FrontendSDK.prototype.getClient = function (mainTokenKey) {
        if (!this.client) {
            this.client = new Client_1.default(mainTokenKey);
        }
        return this.client;
    };
    FrontendSDK.prototype.getServiceClient = function (serviceKey, mainTokenKey) {
        return new ServiceClient_1.default(serviceKey, mainTokenKey);
    };
    FrontendSDK.getInstance = function () {
        if (!this.instance) {
            this.instance = new FrontendSDK();
        }
        return this.instance;
    };
    FrontendSDK.isValidJWT = function (jwt) {
        return User_1.default.isValidJWT(jwt);
    };
    FrontendSDK.prototype.logoutUser = function (url, project_key) {
        if (project_key) {
            document.cookie = project_key + "-token='';";
        }
        window.location.href = url.endsWith('/') ? url + "logout" : url + "/logout";
    };
    FrontendSDK.prototype.goToProfileSetting = function (url) {
        window.location.href = url.endsWith('/') ? url + "user/profile_settings" : url + "/user/profile_settings";
    };
    FrontendSDK.prototype.goToAccountSetting = function (url) {
        window.location.href = url.endsWith('/') ? url + "user/account_settings" : url + "/user/account_settings";
    };
    FrontendSDK.prototype.getCountNewNotification = function (ident_endpoint) {
        return __awaiter(this, void 0, void 0, function () {
            var request, res, resJson;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        request = this.getRequest(ident_endpoint);
                        return [4 /*yield*/, request.get('/notification/count-new', {
                                credentials: 'include',
                            })];
                    case 1:
                        res = _a.sent();
                        return [4 /*yield*/, res.json()];
                    case 2:
                        resJson = _a.sent();
                        return [2 /*return*/, resJson.count || 0];
                }
            });
        });
    };
    FrontendSDK.prototype.goToNotification = function (url) {
        window.location.href = url.endsWith('/') ? url + "notifications" : url + "/notifications";
    };
    return FrontendSDK;
}());
exports.default = FrontendSDK;
//# sourceMappingURL=FrontendSDK.js.map