import Request from './../request/Request';
import IAuthResponse from './../interfaces/IAuthResponse';
export interface IRole {
    key: string;
    name: string;
}
export interface IRegistrationParams {
    service_key: string;
    display_name: string;
    short_name: string;
    service_url: string;
    frontend_url: string;
    roles: Array<IRole>;
    is_visible: boolean;
}
export interface IRegistrationResponse {
    jwt_secret?: string;
}
export default class Client extends Request {
    protected service: string;
    protected identEndpoint: string;
    protected mainTokenKey: string;
    constructor(mainTokenKey: string);
    auth(identEndpoint: string): Promise<IAuthResponse>;
    register(endpoint: string, params: IRegistrationParams): Promise<void>;
    getServiceKey(): string;
}
//# sourceMappingURL=Client.d.ts.map