"use strict";
var stringify = require('.');
var StringDecoder = require('string_decoder').StringDecoder;
module.exports = function (records, options) {
    if (options === void 0) { options = {}; }
    var data = [];
    if (Buffer.isBuffer(records)) {
        var decoder = new StringDecoder();
        records = decoder.write(records);
    }
    function onData(record) {
        if (record) {
            data.push(record.toString());
        }
    }
    var stringifier = new stringify.Stringifier(options);
    stringifier.on('data', onData);
    for (var _i = 0, records_1 = records; _i < records_1.length; _i++) {
        var record = records_1[_i];
        stringifier.write(record);
    }
    stringifier.end();
    stringifier.off('data', onData);
    return data.join('');
};
//# sourceMappingURL=sync.js.map