"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseCookie = exports.getCookie = exports.isObject = exports.md5 = void 0;
var crypto_browserify_1 = require("crypto-browserify");
var md5 = function (str) {
    if (typeof str !== 'string') {
        throw new Error('The parameter must be a string');
    }
    return crypto_browserify_1.createHash('md5')
        .update(str.trim())
        .digest('hex');
};
exports.md5 = md5;
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
var isObject = function (obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
};
exports.isObject = isObject;
var getCookie = function (name) {
    var requestedCookie = exports.parseCookie().find(function (e) { return e[name]; });
    return requestedCookie
        ? requestedCookie[name]
        : null;
};
exports.getCookie = getCookie;
var parseCookie = function () {
    return document.cookie
        .split(';')
        .map(function (e) { return e.trim(); })
        .map(function (e) {
        var _a;
        var cookieParts = e
            .split('=')
            .map(function (c) { return c.trim(); });
        return _a = {},
            _a[cookieParts[0]] = cookieParts[1],
            _a;
    });
};
exports.parseCookie = parseCookie;
//# sourceMappingURL=Misc.js.map